﻿using System;
using Eingabeverwaltung.Metamodell;

namespace Ueberpruefung
{
    public class CheckLemmaIsAcyclic : ElementChecker
    {
        public CheckLemmaIsAcyclic() { }
        public override bool check(Element e)
        {
            if (e is Lemma l)
            {
                bool result = l.cyclicDependencies.Count == 0;
                if (!result)
                {
                    string output = "{ ";
                    foreach (Lemma dep in l.cyclicDependencies) output += dep.name + " ";
                    output += "}";
                    l.errors.Add(new Error(20,output));
                }
                return result;
            }
            else throw new InvalidOperationException();
        }
    }
}
